/*

Crow_bar(c) module loading code for DQ compilers

*/

#include <pspsdk.h>
#include <pspkernel.h>
#include <pspdebug.h>
#include <psppower.h>
#include <pspctrl.h>
#include <psploadexec_kernel.h>
#include <kubridge.h>
#include <systemctrl.h>
#include <systemctrl_se.h>
extern"C"
{
 #include "rdriver.h"
}
#include <string.h>

PSP_MODULE_INFO("DQ_KERNEL", PSP_MODULE_USER, 1, 0);
PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER | PSP_THREAD_ATTR_VFPU);
PSP_HEAP_SIZE_KB(-1024);

#define printf	pspDebugScreenPrintf
#define color   pspDebugScreenSetTextColor

#define BSPFILE "ms0:/testrez/emitters.map"

int main(int argc, char **argv)
{
    int apitype = 0;
	char *name = NULL;
	char *mode = NULL;
	scePowerSetClockFrequency(333, 333, 166);
    struct SceKernelLoadExecVSHParam param;

	pspDebugScreenInit();
    pspDebugScreenClear();

    SceUID mod = sceKernelLoadModule("rdriver.prx", 0, NULL);
	if (mod >= 0)
	{
		mod = sceKernelStartModule(mod, 0, NULL, NULL, NULL);
		if (mod < 0)
			printf("Error 0x%08X starting module.\n", mod);
	}
	else
	{
		if (mod == SCE_KERNEL_ERROR_EXCLUSIVE_LOAD)
		{
			// Ignore this error, it means the module loaded on reboot
		}
		else
		{
			printf("Error 0x%08X loading module.\n",  mod);
		}
	}


    //setup Pad
	SceCtrlData pad;
	u32 oldButtons = 0;
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(0);

	color(0x40ff00);
    printf("\n");
    printf("++++++++++++++++++++++++++++++++++++\n");
    printf("++++ PSP Bsp Tools  By Crow_bar ++++\n");
    printf("+ Press  CROSS    to load Treeqbsp +\n");
    printf("+ Press  SQUARE   to load Vis      +\n");
    printf("+ Press TRIANGLE  to load Light    +\n");
    printf("++++++++++++++++++++++++++++++++++++\n");
    printf("\n");

	int done = 0;
	while(!done)
	{
       sceCtrlReadBufferPositive(&pad, 1);
		if(oldButtons != pad.Buttons)
		{
			if(pad.Buttons & PSP_CTRL_CROSS)
			{
                apitype = 0x141;
				name = "ms0:/tools/treeqbsp/EBOOT.PBP";
                mode = "game";
				color(0x00ffff);
				printf("Loading Treeqbsp\n");
                printf("\n");
				done = 1;
			}
            else if(pad.Buttons & PSP_CTRL_SQUARE)
			{
                apitype = 0x141;
				name = "ms0:/tools/vis/EBOOT.PBP";
                mode = "game";
			    color(0x00ffff);
				printf("Loading Vis\n");
                printf("\n");
				done = 1;
			}
            else if(pad.Buttons & PSP_CTRL_TRIANGLE)
			{
                apitype = 0x141;
				name = "ms0:/tools/light/EBOOT.PBP";
                mode = "game";
				color(0x00ffff);
				printf("Loading Light\n");
                printf("\n");
				done = 1;
			}
            else if (pad.Buttons & PSP_CTRL_START)
		    {
			  RestoreExitGame();
			  sceKernelExitGame();
		    }
		}
		oldButtons = pad.Buttons;

	    sceKernelDelayThread(50000);

	}
    

	//sceDisplaySetHoldMode(1);
	color(0x0000FF00);
	printf("\nLoading ...\n");

	memset(&param, 0, sizeof(param));
	param.size = sizeof(param);
	param.args = strlen(BSPFILE)+1;
	param.argp = (void*)BSPFILE;
	param.key = mode;

	sctrlKernelLoadExecVSHWithApitype(apitype, name, &param);

    sceKernelSleepThread();

	return 0;
}

