extern "C"
{
#include "../quakedef.h"
}

#include <pspgu.h>
#include <pspgum.h>

#define INTERP_WEAP_MAXNUM		24
#define INTERP_WEAP_MINDIST		5000
#define INTERP_WEAP_MAXDIST		95000
#define	INTERP_MINDIST			70
#define	INTERP_MAXDIST			300



extern float	*shadedots;

// precalculated dot products for quantized angles
#define NUMVERTEXNORMALS	162

//extern "C" float	r_avertexnormals[NUMVERTEXNORMALS][3];
extern float r_avertexnormals[NUMVERTEXNORMALS][3];

#define SHADEDOT_QUANT 16
extern float	r_avertexnormal_dots[SHADEDOT_QUANT][256];

extern float	shadelight, ambientlight;
extern vec3_t   lightcolor; // LordHavoc: .lit support

int loadtextureimage (char* filename, int matchwidth, int matchheight, qboolean complain, int filter);

extern int c_md3_polys;

ScePspFMatrix4	matrix;

extern	vec3_t			lightspot;

extern vec3_t	shadevector;

#include <list>

using namespace std;

extern list<int> mapTextureNameList;

//==============================================================================
qboolean full_light;

/*
=============
R_SetupLighting
=============
*/
void R_SetupLighting (entity_t *ent)
{
	int	i, lnum;
	float	add;
	vec3_t	dist, dlight_color;
	model_t	*clmodel = ent->model;

	// make thunderbolt and torches full light
	if (clmodel->modhint == MOD_THUNDERBOLT)
	{
		ambientlight = 210;
		shadelight = 0;
		full_light = ent->noshadow = qtrue;
		return;
	}
	else if (clmodel->modhint == MOD_FLAME)
	{
		ambientlight = 255;
		shadelight = 0;
		full_light = ent->noshadow = qtrue;
		return;
	}

	// normal lighting
	ambientlight = shadelight = R_LightPoint (ent->origin);
 	full_light = qfalse;
	ent->noshadow = qfalse;

	for (lnum = 0 ; lnum < MAX_DLIGHTS ; lnum++)
	{
		if (cl_dlights[lnum].die < cl.time || !cl_dlights[lnum].radius)
			continue;

		VectorSubtract (ent->origin, cl_dlights[lnum].origin, dist);
		add = cl_dlights[lnum].radius - VectorLength (dist);

		if (add > 0)
		{
/*
		// joe: only allow colorlight affection if dynamic lights are on
			if (r_dynamic.value)
			{
				VectorCopy (bubblecolor[cl_dlights[lnum].type], dlight_color);
				for (i=0 ; i<3 ; i++)
				{
					lightcolor[i] = lightcolor[i] + (dlight_color[i] * add) * 2;
					if (lightcolor[i] > 256)
					{
						switch (i)
						{
						case 0:
							lightcolor[1] = lightcolor[1] - (lightcolor[1] / 3);
							lightcolor[2] = lightcolor[2] - (lightcolor[2] / 3);
							break;

						case 1:
							lightcolor[0] = lightcolor[0] - (lightcolor[0] / 3);
							lightcolor[2] = lightcolor[2] - (lightcolor[2] / 3);
							break;

						case 2:
							lightcolor[1] = lightcolor[1] - (lightcolor[1] / 3);
							lightcolor[0] = lightcolor[0] - (lightcolor[0] / 3);
							break;
						}
					}
				}
			}
*/
			ambientlight = shadelight += add;//r00k
		}
	}

	// clamp lighting so it doesn't overbright as much
	ambientlight = fmin(128, ambientlight);
	if (ambientlight + shadelight > 192)
		shadelight = 192 - ambientlight;

	if (ent == &cl.viewent)
	{
		ent->noshadow = qtrue;
		// always give the gun some light
		if (ambientlight < 24)
			ambientlight = shadelight = 24;
	}

	// never allow players to go totally black
	//if ((clmodel->modhint == MOD_PLAYER) || (clmodel->modhint == MOD_EYES))//R00k
	{
		if (ambientlight < 8)
			ambientlight = shadelight = 8;
	}
}





